/*
 * MeinPick.java
 *
 * Created on 10. Mai 2003, 20:52
 */


package Aufgabe;

import javax.media.j3d.*;
import java.awt.AWTEvent;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame; 
import com.sun.j3d.utils.universe.*;
import javax.vecmath.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.util.Enumeration;
import com.sun.j3d.utils.geometry.*;
/**
 *
 * @author  Tobias
 */
public class MeinPick extends javax.media.j3d.Behavior {
    Canvas3D m_Canvas;
    Locale m_Wurzel;
    WakeupCriterion wakeupCriteria = new WakeupOnAWTEvent(MouseEvent.MOUSE_CLICKED);
    Box m_target;
    
    public MeinPick(Canvas3D canvas, Locale wurzel, Box target) {
        m_Canvas = canvas;
        m_Wurzel = wurzel;
        m_target = target;
    }
    
    public void initialize() {
        wakeupOn(wakeupCriteria);
    }
    
    public void processStimulus( java.util.Enumeration criteria ) {
        WakeupOnAWTEvent ev;
	WakeupCriterion genericEvt;
	AWTEvent[] event;
	boolean sawFrame = false;

        genericEvt = (WakeupCriterion) criteria.nextElement();
	if (genericEvt instanceof WakeupOnAWTEvent) {
            ev = (WakeupOnAWTEvent) genericEvt;
            event = ev.getAWTEvent();
            werteAus(event);	
            wakeupOn( wakeupCriteria );
       }
    }
   private void werteAus(AWTEvent[] e) {
       MouseEvent eventButton;
       int x,y;
       if (e[0] instanceof MouseEvent) {
	eventButton = (MouseEvent)e[0];
	
	if (eventButton.getID() == MouseEvent.MOUSE_CLICKED) {
           x = eventButton.getX();
           y = eventButton.getY();
           
           PickRay ray = createPickRay(m_Canvas, x, y);
           SceneGraphPath path = m_Wurzel.pickAny(ray);
       if (path != null)  {
           if ((path.getObject().equals(m_target.getShape(1))) || (path.getObject().equals(m_target.getShape(4)))) 
               postId(7);
                
        }} }
   } 
    
  private PickRay createPickRay(Canvas3D canvas, int x, int y)
  {
  Point3d eye_pos = new Point3d();
  Point3d mouse_pos = new Point3d();

  canvas.getCenterEyeInImagePlate(eye_pos);
  canvas.getPixelLocationInImagePlate(x, y, mouse_pos);

  Transform3D motion = new Transform3D();
  canvas.getImagePlateToVworld(motion);
  motion.transform(eye_pos);
  motion.transform(mouse_pos);

  Vector3d direction = new Vector3d(mouse_pos);
  direction.sub(eye_pos);

  return new PickRay(eye_pos, direction);
}


   
}
